/*
 ============================================================================
 Name        : Pipe.c
 Author      : nome
 Version     :
 Copyright   : sistemi operativi
 Description : Hello World in C, Ansi-style
 ============================================================================
 */

#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>

int main(void) {
	int k, n, id, pid, status;
	char line[100], cid[100];
	int fd[2];
	FILE * instr = NULL;
	FILE * outstr = NULL;

	if (pipe( fd) < 0) {
		fprintf(stderr, "Errore sulla pipe\n");
		exit(0);
	}

	if ((pid = fork()) < 0) {
		// errore
		fprintf(stderr, "fork failed\n");
	} else if (pid > 0) {
		// processo padre
		close( fd[0]);
		if ((stdout = fdopen( fd[1], "w")) == NULL) {
			fprintf(stderr, "Padre  fdopen failed");
			exit(-1);
		}
		fprintf(stderr, "stdout fileno: %d (pipe fd[1] = %d)\n", fileno(stdout), fd[1]);
/*		if (fd[1] != STDOUT_FILENO) {
			if (dup2(fd[1], STDOUT_FILENO) != STDOUT_FILENO)
				fprintf(stderr, "dup2 error to stdout\n");
			// close(fd[1]); // don't need this after dup2
			fprintf(stderr, "Proc id %d %d closed, %d dup\n", id, fd[1], STDOUT_FILENO);
		}
*/
		fprintf(stdout, "test pipe\n");
		fflush(stdout);
		wait(&status);
		fprintf(stderr, "Fine padre, status: %d\n", status);
		fclose( stdout);
	} else {
		// processo figlio
		close(fd[1]);
		if ((stdin = fdopen( fd[0], "r")) == NULL) {
			fprintf(stderr, "figlio  fdopen failed");
			exit(-1);
		}
		fprintf(stderr, "stdin fileno: %d (pipe fd[0] = %d)\n", fileno(stdin), fd[0]);
/*
 		if (fd[0] != STDIN_FILENO) {
			if (dup2(fd[0], STDIN_FILENO) != STDIN_FILENO)
				fprintf(stderr, "dup2 error to stdin\n");
			// close(fd[0]); // don't need this after dup2
			fprintf(stderr, "Proc id %d %d closed, %d dup\n", id, fd[0], STDIN_FILENO);
		}
*/
		fprintf(stderr, "waiting\n");
		fgets(line, 100, stdin); line[strlen(line) - 1] = '\0';
		fprintf(stderr, "got: <<%s>>\n", line);
		fprintf(stderr, "fine child process\n");
		exit(2);
	}
}
