/*
 ============================================================================
 Name        : Pipe.c
 Author      : nome
 Version     :
 Copyright   : sistemi operativi
 Description : Hello World in C, Ansi-style
 ============================================================================
 */

#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>

int main(void) {
	int k, n, id, pid, status;
	char line[100], cid[100];
	int fd[2];

	if (pipe(fd) < 0) {
		fprintf(stderr, "pipe error\n");
		exit(-1);
	}
	if ((pid = fork()) < 0) {
		fprintf(stderr,"fork error\n");
	}
	else if (pid > 0) { // processo padre
		close(fd[0]);
		write(fd[1], "hello world\n", 12);
		fprintf(stderr, "Fine padre, waiting for child\n");
		wait(&status);
		fprintf(stderr, "status: %d\n", status);
		close( fd[1]);
	}
	else { // processo figlio
		close(fd[1]);
		n = read(fd[0], line, 100);
		write(STDOUT_FILENO, line, n);
		fprintf(stderr, "fine figlio, exiting\n");
		exit(1);
	}
}

